Name:       netcat-openbsd
Version:    1.89
Release:    %mkrel 16
Summary:    Reads and writes data across network connections using TCP or UDP
Group:      Networking/Other
License:    BSD
URL:        https://www.openbsd.org/cgi-bin/cvsweb/src/usr.bin/nc/
# source is CVS checkout
Source0:    netcat-openbsd-%{version}.tar.gz
Patch0:     openbsd-compat.patch
Patch1:     socks-b64-prototype.patch
Patch2:     silence-z.patch
Patch3:     glib-strlcpy.patch
Patch4:     no-strtonum.patch
Patch5:     pollhup.patch
Patch6:     reuseaddr.patch
# add a timeout on connexion
Patch7:     connect-timeout.patch
Patch8:     udp-scan-timeout.patch
# be verbose when receiving a connexion ( show port number )
Patch9:     verbose-numeric-port.patch
Patch10:    send-crlf.patch
Patch11:    help-version-exit.patch
Patch12:    quit-timer.patch
Patch13:    getservbyname.patch
Patch14:    gcc-warnings.patch
# add support for non openbsd plateform
Patch20:    netcat-openbsd-1.89-makefile.patch
Patch21:    netcat-openbsd-1.89-openbsd-compat.patch
BuildRequires:  glib2-devel
Provides:       netcat = 1.0

%description
The nc package contains Netcat (the program is actually nc), a simple
utility for reading and writing data across network connections, using
the TCP or UDP protocols. Netcat is intended to be a reliable back-end
tool which can be used directly or easily driven by other programs and
scripts.  Netcat is also a feature-rich network debugging and
exploration tool, since it can create many different connections and
has many built-in capabilities.

You may want to install the netcat package if you are administering a
network and you'd like to use its debugging and network exploration
capabilities.

%prep
%setup -q -n netcat-openbsd-%{version}.orig

%patch -P 20 -p1
%patch -P 21 -p1

%patch -P 0 -p1
%patch -P 1 -p1
%patch -P 2 -p1
%patch -P 3 -p1
%patch -P 4 -p1
%patch -P 5 -p1
%patch -P 6 -p1
%patch -P 7 -p1
%patch -P 8 -p1
%patch -P 9 -p1
%patch -P 10 -p1
%patch -P 11 -p1
%patch -P 12 -p1
%patch -P 13 -p1
%patch -P 14 -p1

%build
%make_build CFLAGS="%{optflags} -std=gnu17" LDFLAGS="%{ldflags}"

%install
install -Dpm 755 nc %{buildroot}%{_bindir}/nc-openbsd
install -Dpm 644 nc.1 %{buildroot}%{_mandir}/man1/nc-openbsd.1

# for alternatives
touch %{buildroot}%{_bindir}/nc
touch %{buildroot}%{_bindir}/netcat
touch %{buildroot}%{_mandir}/man1/nc.1%{?_extension}
touch %{buildroot}%{_mandir}/man1/netcat.1%{?_extension}

%triggerprein -- netcat-openbsd < 1.89-14
if [ -f %{_bindir}/nc ]; then
  rm -rf %{_bindir}/nc
fi
if [ -f %{_mandir}/man1/nc.1%{?_extension} ]; then
  rm -rf %{_mandir}/man1/nc.1%{?_extension}
fi

%post
%{_sbindir}/alternatives \
  --install %{_bindir}/nc nc %{_bindir}/nc-openbsd 4 \
  --slave %{_bindir}/netcat netcat %{_bindir}/nc-openbsd \
  --slave %{_mandir}/man1/nc.1.xz nc-man %{_mandir}/man1/nc-openbsd.1.xz \
  --slave %{_mandir}/man1/netcat.1.xz netcat-man %{_mandir}/man1/nc-openbsd.1.xz

%preun
if [ $1 -eq 0 ]; then
  %{_sbindir}/alternatives --remove nc %{_bindir}/nc-openbsd
fi

%files
%ghost %{_bindir}/nc
%ghost %{_bindir}/netcat
%{_bindir}/nc-openbsd
%ghost %{_mandir}/man1/nc.1*
%ghost %{_mandir}/man1/netcat.1*
%{_mandir}/man1/nc-openbsd.1*


%changelog
* Wed May 21 2025 ns80 <ns80> 1.89-16.mga10
+ Revision: 2185506
- try to fix building with GCC 15

* Sat Nov 09 2024 wally <wally> 1.89-15.mga10
+ Revision: 2113388
- build using our LDFLAGS
- use alternatives system

* Thu Mar 17 2022 umeabot <umeabot> 1.89-13.mga9
+ Revision: 1795144
- Mageia 9 Mass Rebuild

* Thu Feb 13 2020 umeabot <umeabot> 1.89-12.mga8
+ Revision: 1515341
- Mageia 8 Mass Rebuild

* Sun Sep 23 2018 umeabot <umeabot> 1.89-11.mga7
+ Revision: 1299700
- Mageia 7 Mass Rebuild

* Thu Aug 31 2017 daviddavid <daviddavid> 1.89-10.mga7
+ Revision: 1148848
- honor user CFLAGS thus fixing empty debugsourcefiles.list

* Tue Feb 02 2016 umeabot <umeabot> 1.89-9.mga6
+ Revision: 930923
- Mageia 6 Mass Rebuild

* Wed Oct 15 2014 umeabot <umeabot> 1.89-8.mga5
+ Revision: 742827
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1.89-7.mga5
+ Revision: 682843
- Mageia 5 Mass Rebuild

* Fri Oct 18 2013 umeabot <umeabot> 1.89-6.mga4
+ Revision: 508320
- Mageia 4 Mass Rebuild
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Apr 05 2011 misc <misc> 1.89-4.mga1
+ Revision: 80683
- comment some patches ( but there is too much of them for now )
- rebuild and import on Mageia
- imported package netcat-openbsd


* Wed Jan 21 2009 Guillaume Rousse <guillomovitch@mandriva.org> 1.89-3mdv2009.1
+ Revision: 332126
- provides a versionned netcat virtual package

* Mon Jan 19 2009 Guillaume Rousse <guillomovitch@mandriva.org> 1.89-2mdv2009.1
+ Revision: 331436
- package renaming
- ship netcat binary and man page
- provides netcat virtual package
- package renaming

* Fri Jan 16 2009 Guillaume Rousse <guillomovitch@mandriva.org> 1.89-1mdv2009.1
+ Revision: 330355
- sync with debian package

* Tue Jul 29 2008 Thierry Vignaud <tvignaud@mandriva.com> 1.84-3mdv2009.0
+ Revision: 253765
- rebuild

* Thu Jan 03 2008 Olivier Blin <oblin@mandriva.com> 1.84-1mdv2008.1
+ Revision: 140994
- restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Sun Sep 23 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 1.84-1mdv2008.0
+ Revision: 92310
- Fixed License tag (BSD instead of GPL).

  + Guillaume Rousse <guillomovitch@mandriva.org>
    - import netcat-bsd

